Improve watchers functionality to mark the users that are watching a non visible object and to not
return watchers that cannot see the object
Description

The scope of this issue is to decrease the confusion created by the actual watchers implementation which allows you to add to an
object (issue, wiki, news) a watcher who doesn't have permissions to view that object. There are multiple open issues generated by
this issue, but | opted to create a new issue, clean, to discuss some proposal that | have in plan. At the end, depending on what it's
implemented, we close those issues.

| made three patches:

1. 0001-Fix-typo-in-find_objects_from_params.patch
It just fix a typo in the code.

2. 0002-Do-not-propose-watchers-that-are-not-allowed-to-see-.patch
The patch changes the behaviour of method users_for_new_watcher to reject users who doesn't have the permissions to view the
object. This change applies only when the search is made for one object (eg: issue), not for multiple objects (add bulk watchers).

3. 0003-Show-an-warning-message-for-watchers-who-cannot-view
Because the second patch doesn't cover all the cases and it's difficult to cover all the cases, I've added in the Ul an warning next to
an invalid watcher with the following warning message: "Invalid watcher: User will not receive any notifications because it does not
have access to view this object.". Any feedback on the message is welcome.

invalid_watcher.png

What else | have in mind:

4. Limit the number of results returned by the auto complete method to a maximum 20 or 30 objects in order to avoid performance
issues (we need to iterate through each object to check the visibility). Right now, when a term is used in the search, the
autocomplete returns all the results found, else returns the first 100 results. It's hard to believe that an user prefer to scroll down in
the list of returned watchers instead of typing a more complete search term.

5. Return an error or an warning message when a watcher is added to an object not visible.

Related issues:

Related to Redmine - Defect #22977: A project member has no access and gets n... New

Related to Redmine - Defect #5679: Watchers not cleaned/updated when deleting... Closed 2010-06-12
Related to Redmine - Defect #11888: No e-mail notification for non-members wh... New

Related to Redmine - Patch #16133: Available watchers on new issue form inclu... Closed

Related to Redmine - Defect #35192: Watchers pop up window appears after a lo... New

Related to Redmine - Defect #36549: Issues with watchers and restricted tickets Closed

Related to Redmine - Defect #37224: Add watchers to issue New

Associated revisions

Revision 20724 - 2021-01-24 06:31 - Go MAEDA

Do not propose watchers that are not allowed to see the object (#33329).

Patch by Marius BALTEANU.

Revision 20725 - 2021-01-24 06:38 - Go MAEDA

Show a warning message for watchers who cannot view the object (#33329).

Patch by Marius BALTEANU.
Revision 20726 - 2021-01-24 06:41 - Go MAEDA
Update locales (#33329).

History

#1 - 2020-04-20 16:27 - Marius BALTEANU

- Related to Defect #22977: A project member has no access and gets no notification, when being a watcher of the issue added

#2 - 2020-04-20 16:57 - Marius BALTEANU
- Related to Defect #5679: Watchers not cleaned/updated when deleting/moving watched object added

#3 - 2020-04-25 09:01 - Go MAEDA

Looks good to me.

A similar patch #16133 was rejected 5 years ago due to performance concerns when a project has a lot of members, but | think
0002-Do-not-propose-watchers-that-are-not-allowed-to-see-.patch does not introduce the performance problem because watchable_object.visible? is
only called 200 times, only when the user open Add watchers dialog.

#4 - 2020-04-25 09:45 - Marius BALTEANU
- Assignee deleted (Marius BALTEANU)

- Target version changed from Candidate for next major release to 4.2.0

Go MAEDA wrote:
Looks good to me.

A similar patch #16133 was rejected 5 years ago due to performance concerns when a project has a lot of members, but | think
0002-Do-not-propose-watchers-that-are-not-allowed-to-see-.patch does not introduce the performance problem because
watchable_object.visible? is only called 200 times, only when the user open Add watchers dialog.

I'm adding this to 4.2.0 in order to discuss and find some solutions to fix the current annoying behaviour. We can limit the number of calls made by
watchable_object.visible? by limiting the number of results returned from the database (proposal nr#4). Regarding patch nr#3, if the overall idea is
accepted, we can load the watchers async always or only when there are more than x watchers. I'm sure that we can find good solutions without
performance degradation.

#5 - 2020-12-14 02:38 - Go MAEDA

- Related to Defect #11888: No e-mail notification for non-members who are watchers added

#6 - 2021-01-24 06:41 - Go MAEDA
- Category set to Issues
- Status changed from New to Closed

- Assignee set to Go MAEDA
Committed the patches. Thank you for improving Redmine.

#7 - 2021-01-24 06:47 - Go MAEDA

- Related to Patch #16133: Available watchers on new issue form include users who cannot even view issues added

#8 - 2021-05-03 23:15 - Marius BALTEANU
- Related to Defect #35192: Watchers pop up window appears after a long time added

#9 - 2022-02-01 17:15 - Holger Just
- Related to Defect #36549: Issues with watchers and restricted tickets added

#10 - 2022-06-09 17:36 - Holger Just
- Related to Defect #37224: Add watchers to issue added

#11 - 2024-11-08 12:57 - Jenda Benda

Hello, everyone,
thanks for your work.

Related to these changes, | believe, having ability to add us user as a watcher and to get a message later on he/she can see the issue is little bit
weird...

Also adding rights to the watcher for the issue means currently (if I'm not mistaken) to add him ability to see all the issues within whole project, which
is not wanted in most cases. When someone can't see all the issues it's usually ofr some reason. And when adding as a watcher of one shouldn't
require permission for all.

| believe we need something like this (soft read only permission for watched issues):

https://github.com/maxrossello/redmine_extended watchers

Thank you so much
Kind regards
Jan

#12 - 2024-11-08 17:41 - Holger Just

Jenda Benda wrote in #note-11:

Related to these changes, | believe, having ability to add us user as a watcher and to get a message later on he/she can see the issue is little bit
weird...

In an unchanged Redmine, you can only add a watcher to an issue if the user can already see the issue. It is however possible that later on, the user
loses the right to see the issue. In that case, they still remain a watcher but will not receive any notifications for the issue nor will they be able to see it.
For other users, the watcher will then be rendered with the "invalid watcher" message.

Also adding rights to the watcher for the issue means currently (if I'm not mistaken) to add him ability to see all the issues within whole project,
which is not wanted in most cases.

That is not correct. In a default Redmine, adding a watcher does not add any additional permissions and thus does not allow the watcher to see an
issue they can not see otherwise. There is however a feature request to update the watchers functionality to grant watchers read-only permissions to
issues they watch, see #8488.

Here (and in all plugins and related implementations I'm aware, including on Planio), adding a watcher to an issue will only grant the watcher
additional read access to this single issue, not to all issues in the project.

When someone can't see all the issues it's usually ofr some reason. And when adding as a watcher of one shouldn't require permission for all.

Yes, that is the behavior of Redmine.
| believe we need something like this (soft read only permission for watched issues):

https://github.com/maxrossello/redmine_extended watchers

This plugin implements a similar functionality to what is described in #8488, #7412, #23546 and several other similar issues. Initially this change was
rejected by Jean-Philippe Lang. See #7412#note-13

#13 - 2024-11-08 18:50 - Jenda Benda

Hello, thanks for the reply and all the information.

I'm not sure why, but in our redmine instance we can add "watchers" role to the users that can't see the issue, but are members of the same project.
The instalation is 2 week fresh, where we have just "additionals" plugin installed. This is probably the only thing that might change the default
behavior, but | doubt it is the case... Any idea how's that possible then?

That's the reason why we are getting into the weird situation, where anyone can assign as a watcher anyone from the same project(customer), but
then gets the warning message about the user not being able to see the issue.

That is not correct. In a default Redmine, adding a watcher does not add any additional permissions and thus does not allow the watcher to see
an issue they can not see otherwise. There is however a feature request to update the watchers functionality to grant watchers read-only
permissions to issues they watch, see #8488.

I'm sorry for bad explanation/wording... | meant that currently if we would like to enable watchers to be added to the certain issues in their project....we
have to allow them to see all the issues of the project manually first.

Is there any other way how to assign an issue to the users of the same project who can't see all the issues within the project?

The thing is we were used to (e.g. in Jira) to do that. But at the same time we do not want users to see all issues by default (just in case anyone would
like to assign them as watchers)...

thank you so much
Kind regards
Jan

#14 - 2024-11-08 20:40 - Holger Just

Please move this discussion over to the forums. This unrelated and closed issue is not the right place for this.

#15 - 2024-11-13 19:46 - Jenda Benda
- File clipboard-202411131942-trncf.png added

OK, I will and thank you so much.

just a quick note...following permissions setting with "add watcher" permission allow users to add watcher to issues thay can't see-(
clipboard-202411131942-trncf.png

I'd assume, that in case we "assign" an issue to a user in the form of "watcher" it should be considered as an issue the "watching user" should be able
to see also. Not to see just issues directly assigned as a resolver/assignee, otherwise this possibility doesn't make much sense and user will end-up
with error messaage (This message will be shown only after assigning user as a watcher).

Btw. I've just found out that what | stated is valid for newly created issues only - in the porcess of creating new issue, a watcher can be
added despite the fact he/she can't see the issue. When you try to do the same for an existing issue, it won't show you users who can't see
the issue.

thx
Kind regards

]-

Files

0002-Do-not-propose-watchers-that-are-not-allowed-to-see-.patch 2.01 KB 2020-04-20 Marius BALTEANU
